Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs	(revision 14333)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.GoalSeekingProblem.Views {
+  [Plugin("HeuristicLab.GoalSeekingProblem.Views", "3.4.0.0")]
+  [PluginFile("HeuristicLab.GoalSeekingProblem.Views-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+
+  public class HeuristicLabProcessParameterOptimizationPlugin : PluginBase {
+  }
+}
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs.frame	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Plugin.cs.frame	(revision 14333)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.GoalSeekingProblem.Views {
+  [Plugin("HeuristicLab.GoalSeekingProblem.Views", "3.4.0.0")]
+  [PluginFile("HeuristicLab.GoalSeekingProblem.Views-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+
+  public class HeuristicLabProcessParameterOptimizationPlugin : PluginBase {
+  }
+}
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/PreBuildEvent.cmd	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/PreBuildEvent.cmd	(revision 14333)
@@ -0,0 +1,11 @@
+IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+GOTO Done
+
+:Error_Handling
+ECHO There was an error while running subwcrev. Please verify that the *.cs.frame files have been correctly converted to *.cs files, otherwise HeuristicLab won't build. 
+exit 0
+
+:Done
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Properties/AssemblyInfo.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Properties/AssemblyInfo.cs	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.Views/3.4/Properties/AssemblyInfo.cs	(revision 14333)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("GoalSeekingProblem.Views")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("GoalSeekingProblem.Views")]
+[assembly: AssemblyCopyright("Copyright ©  2016")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("b0cbff1b-6a06-4dda-b622-e847b8adc908")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.sln
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.sln	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem.sln	(revision 14333)
@@ -0,0 +1,48 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 14
+VisualStudioVersion = 14.0.25420.1
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "GoalSeekingProblem", "HeuristicLab.GoalSeekingProblem\3.4\GoalSeekingProblem.csproj", "{79271BC8-4446-40E2-BB89-9BE4E17174FE}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "GoalSeekingProblem.Views", "HeuristicLab.GoalSeekingProblem.Views\3.4\GoalSeekingProblem.Views.csproj", "{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Debug|x64 = Debug|x64
+		Debug|x86 = Debug|x86
+		Release|Any CPU = Release|Any CPU
+		Release|x64 = Release|x64
+		Release|x86 = Release|x86
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|x64.ActiveCfg = Debug|x64
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|x64.Build.0 = Debug|x64
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|x86.ActiveCfg = Debug|x86
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|x86.Build.0 = Debug|x86
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|Any CPU.Build.0 = Release|Any CPU
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|x64.ActiveCfg = Release|x64
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|x64.Build.0 = Release|x64
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|x86.ActiveCfg = Release|x86
+		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Release|x86.Build.0 = Release|x86
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|x64.Build.0 = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Debug|x86.Build.0 = Debug|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|Any CPU.Build.0 = Release|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|x64.ActiveCfg = Release|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|x64.Build.0 = Release|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|x86.ActiveCfg = Release|Any CPU
+		{B0CBFF1B-6A06-4DDA-B622-E847B8ADC908}.Release|x86.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalParameter.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalParameter.cs	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalParameter.cs	(revision 14333)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.GoalSeeking {
+  [Item("GoalParameter", "An object describing a tunable parameter used in goal seeking.")]
+  [StorableClass]
+  public class GoalParameter : NamedItem {
+    [Storable]
+    private double goal;
+    public double Goal {
+      get { return goal; }
+      set {
+        if (goal.IsAlmost(value)) return;
+        goal = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double weight;
+    public double Weight {
+      get { return weight; }
+      set {
+        if (weight.IsAlmost(value)) return;
+        weight = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double variance;
+
+    public double Variance {
+      get { return variance; }
+      set {
+        if (variance.IsAlmost(value)) return;
+        variance = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double step;
+    public double Step {
+      get { return step; }
+      set {
+        if (step.IsAlmost(value)) return;
+        step = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private bool active;
+    public bool Active {
+      get { return active; }
+      set {
+        if (active == value) return;
+        active = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    public override string ToString() {
+      return string.Format("{0} [active: {1}; goal: {2}; weight: {3}; variance: {4}; step: {5}", Name, Active, Goal, Weight, Variance, Step);
+    }
+
+    protected GoalParameter(GoalParameter original, Cloner cloner) : base(original, cloner) {
+      name = original.name;
+      goal = original.goal;
+      weight = original.weight;
+      variance = original.variance;
+      step = original.step;
+      active = original.active;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GoalParameter(this, cloner);
+    }
+
+    [StorableConstructor]
+    protected GoalParameter(bool deserializing) : base(deserializing) { }
+
+    public GoalParameter(string name, double goal, double weight, double variance, double step, bool active = true) {
+      this.name = name;
+      this.goal = goal;
+      this.weight = weight;
+      this.variance = variance;
+      this.step = step;
+      this.active = active;
+    }
+
+    public event EventHandler Changed;
+    private void OnChanged(object sender, EventArgs args) {
+      var changed = Changed;
+      if (changed == null) return;
+      changed(sender, args);
+    }
+  }
+}
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingProblem.csproj
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingProblem.csproj	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingProblem.csproj	(revision 14333)
@@ -189,4 +189,7 @@
     <None Include="Plugin.cs.frame" />
     <Compile Include="Analyzers\BestSolutionAnalyzer.cs" />
+    <Compile Include="GoalParameter.cs" />
+    <Compile Include="GoalSeekingUtil.cs" />
+    <Compile Include="InputParameter.cs" />
     <Compile Include="IGoalSeekingProblem.cs" />
     <Compile Include="Plugin.cs" />
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/GoalSeekingUtil.cs	(revision 14333)
@@ -0,0 +1,132 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.GoalSeeking {
+  internal static class GoalSeekingUtil {
+    internal static void UpdateTargets(ICheckedItemList<GoalParameter> goals, IEnumerable<IRegressionModel> models, EventHandler changedEventHandler) {
+      var targets = models.Select(x => x.TargetVariable).Distinct().OrderBy(x => x);
+      var dict = goals.ToDictionary(x => x.Name, x => x);
+      goals.Clear();
+      foreach (var t in targets) {
+        GoalParameter gp;
+        if (dict.ContainsKey(t)) {
+          gp = dict[t];
+        } else {
+          var goal = double.NaN;
+          var weight = 1.0;
+          var variance = double.NaN;
+          var step = 1e-6;
+          gp = new GoalParameter(t, goal, weight, variance, step, active: false); // new goals are not active by default as they need to be configured by the user
+          gp.Changed += changedEventHandler;
+        }
+        goals.Add(gp, gp.Active);
+      }
+    }
+
+    internal static void UpdateInputs(ICheckedItemList<InputParameter> inputs, IEnumerable<IRegressionModel> models, EventHandler changedEventHandler) {
+      var variables = models.SelectMany(x => x.VariablesUsedForPrediction).Distinct();
+      var dict = inputs.ToDictionary(x => x.Name, x => x); // save old parameter settings
+      inputs.Clear();
+      foreach (var v in variables) {
+        InputParameter ip;
+        if (dict.ContainsKey(v)) {
+          ip = dict[v];
+        } else {
+          ip = new InputParameter(v, double.NaN, -1, 1, 1e-6, active: false); // new inputs are not active by default. the user needs to configure them first
+          ip.Changed += changedEventHandler;
+        }
+        inputs.Add(ip, ip.Active);
+      }
+    }
+
+    internal static RealVectorEncoding CreateEncoding(IEnumerable<InputParameter> inputParameters) {
+      var encoding = new RealVectorEncoding(inputParameters.Count());
+      encoding.Bounds = new DoubleMatrix(encoding.Length, 2); // only two columns: min and max
+      encoding.Bounds.RowNames = inputParameters.Select(x => x.Name);
+      encoding.Bounds.ColumnNames = new[] { "Min.", "Max." };
+
+      int i = 0;
+      foreach (var parameter in inputParameters) {
+        encoding.Bounds[i, 0] = parameter.Min;
+        encoding.Bounds[i, 1] = parameter.Max;
+        ++i;
+      }
+      return encoding;
+    }
+
+    internal static void ValidateGoalsAndInputs(IEnumerable<GoalParameter> goals, IEnumerable<InputParameter> inputs) {
+      var notConfiguredGoals = goals.Where(x => x.Active && (double.IsNaN(x.Variance) || double.IsNaN(x.Goal))).ToList();
+      var notConfiguredInputs = inputs.Where(x => x.Active && (double.IsNaN(x.Min) || double.IsNaN(x.Max) || double.IsNaN(x.Value))).ToList();
+      StringBuilder sb = null;
+      if (notConfiguredGoals.Any()) {
+        sb = new StringBuilder();
+        sb.AppendLine("The following GoalParameters are not configured.");
+        foreach (var goal in notConfiguredGoals) {
+          sb.AppendLine(goal.Name);
+        }
+      }
+      if (notConfiguredInputs.Any()) {
+        if (sb == null)
+          sb = new StringBuilder();
+        sb.AppendLine("The following InpuTParameters are not configured.");
+        foreach (var input in notConfiguredInputs) {
+          sb.AppendLine(input.Name);
+        }
+      }
+      if (sb != null)
+        throw new InvalidOperationException(sb.ToString());
+    }
+
+    internal static void Configure(IEnumerable<GoalParameter> goals, IEnumerable<InputParameter> inputs, IRegressionProblemData problemData, int row) {
+      var inputMap = inputs.ToDictionary(x => x.Name, x => x);
+      var goalMap = goals.ToDictionary(x => x.Name, x => x);
+
+      foreach (var variable in problemData.AllowedInputVariables) {
+        if (inputMap.ContainsKey(variable)) {
+          var values = problemData.Dataset.GetReadOnlyDoubleValues(variable);
+          var input = inputMap[variable];
+          input.Value = values[row];
+          double min = values[0], max = values[0];
+          foreach (var v in values) {
+            if (min > v) min = v;
+            if (max < v) max = v;
+          }
+          input.Min = min;
+          input.Min = max;
+        } else if (goalMap.ContainsKey(variable)) {
+          var values = problemData.Dataset.GetReadOnlyDoubleValues(variable);
+          var goal = goalMap[variable];
+          goal.Variance = values.Variance();
+          goal.Goal = values[row];
+        }
+      }
+    }
+
+    internal static void Goals_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<GoalParameter>> args) {
+      var goals = (CheckedItemList<GoalParameter>)sender;
+      foreach (var item in args.Items.Select(x => x.Value)) {
+        item.Active = goals.ItemChecked(item);
+      }
+    }
+
+    internal static void Inputs_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<InputParameter>> args) {
+      var inputs = (CheckedItemList<InputParameter>)sender;
+      foreach (var item in args.Items.Select(x => x.Value)) {
+        item.Active = inputs.ItemChecked(item);
+      }
+    }
+
+    internal static void RaiseEvent(object sender, EventHandler handler) {
+      if (handler == null) return;
+      handler(sender, EventArgs.Empty);
+    }
+  }
+}
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/IGoalSeekingProblem.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/IGoalSeekingProblem.cs	(revision 14332)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/IGoalSeekingProblem.cs	(revision 14333)
@@ -22,6 +22,4 @@
 using System;
 using System.Collections.Generic;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
@@ -29,9 +27,7 @@
 namespace HeuristicLab.GoalSeeking {
   public interface IGoalSeekingProblem : IProblem {
-    IRegressionProblemData ProblemData { get; set; }
-
+    void Configure(IRegressionProblemData problemData, int row);
     //rounding ? 
     IEnumerable<double> GetEstimatedGoalValues(IEnumerable<double> parameterValues, bool round = false);
-    int Row { get; set; }
 
     //Models?
@@ -39,42 +35,13 @@
     void AddModel(IRegressionModel model);
     void RemoveModel(IRegressionModel model);
+
+    //targets and parameters
+    IEnumerable<GoalParameter> Goals { get; }
+    IEnumerable<InputParameter> Inputs { get; }
+
+    //events
     event EventHandler ModelsChanged;
-
-    #region targets
-    double GetTargetGoal(string target);
-    void SetTargetGoal(string target, double goal);
-
-    //variance ?
-    double GetTargetWeight(string target);
-    void SetTargetWeight(string target, double weight);
-
-    double GetTargetVariance(string target);
-    void SetTargetVariance(string target, double variance);
-
-    double GetTargetStepSize(string target);
-    void SetTargetStepSize(string target, double stepSize);
-
     event EventHandler TargetsChanged;
-    #endregion
-
-    #region parameters
-    ICheckedItemList<StringValue> ControllableParameters { get; }
-    DoubleMatrix ControllableParameterBounds { get; }
-
-    IEnumerable<string> GetControllableParameters();
-    void SetControllableParameters(IEnumerable<string> parameterNames);
-
-    bool GetParameterActive(string parameter);
-    void SetParameterActive(string parameter, bool active);
-
-    double[] GetParameterBounds(string parameterName);
-    void SetParameterBounds(string parameterName, double min, double max, double step);
-    // set get ParameterStepSize, set get parameters active
-    // parameters changed event
-    double GetParameterStepSize(string parameter);
-    void SetParameterStepSize(string parameter, double stepSize);
-
     event EventHandler ParametersChanged;
-    #endregion
   }
 }
Index: /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/InputParameter.cs
===================================================================
--- /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/InputParameter.cs	(revision 14333)
+++ /branches/HeuristicLab.GoalSeekingProblem/HeuristicLab.GoalSeekingProblem/3.4/InputParameter.cs	(revision 14333)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.GoalSeeking {
+  [Item("InputParameter", "An object describing a target for the goal seeking.")]
+  [StorableClass]
+  public class InputParameter : NamedItem {
+    [Storable]
+    private double min;
+    public double Min {
+      get { return min; }
+      set {
+        if (min.IsAlmost(value)) return;
+        min = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double max;
+    public double Max {
+      get { return max; }
+      set {
+        if (max.IsAlmost(value)) return;
+        max = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double step;
+    public double Step {
+      get { return step; }
+      set {
+        if (step.IsAlmost(value)) return;
+        step = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private double value;
+    public double Value {
+      get { return value; }
+      set {
+        if (this.value.IsAlmost(value)) return;
+        this.value = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    [Storable]
+    private bool active;
+    public bool Active {
+      get { return active; }
+      set {
+        if (active == value) return;
+        active = value;
+        OnChanged(this, EventArgs.Empty);
+      }
+    }
+
+    public override string ToString() {
+      return string.Format("{0} [active: {1}; value: {2}; min: {3}; max: {4}; step: {5}]", Name, Active, Value, Min, Max, Step);
+    }
+
+    protected InputParameter(InputParameter original, Cloner cloner) : base(original, cloner) {
+      name = original.name;
+      min = original.min;
+      max = original.max;
+      step = original.step;
+      value = original.value;
+      active = original.active;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new InputParameter(this, cloner);
+    }
+
+    [StorableConstructor]
+    protected InputParameter(bool deserializing) : base(deserializing) { }
+
+    public InputParameter(string name, double value, double min, double max, double step, bool active = true) {
+      this.name = name;
+      this.value = value;
+      this.min = min;
+      this.max = max;
+      this.step = step;
+      this.active = active;
+    }
+
+    public event EventHandler Changed;
+    private void OnChanged(object sender, EventArgs args) {
+      var changed = Changed;
+      if (changed == null) return;
+      changed(sender, args);
+    }
+  }
+}
